Subject: Re: [Pals] Mandatory Encapsulation for BFD in VCCV is lacking in RFC 5885?

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Mon, 16 May 2016 00:09:07 +0000

Sasha,

> On May 15, 2016, at 6:19 AM, Alexander Vainshtein <[email-masked]> wrote:
> 
> Andy, Stewart, Carlos and all,
> I would highly appreciate your feedback on the following issue.
> ( I do not know Tom’s current email address and so cannot send this email to him directly.)
> 
> As you surely remember RFC 5885 <https://tools.ietf.org/html/rfc5885>   has defined two possible encapsulations for BFD in VCCV:
> 1.       Encapsulation that uses IP and UDP headers. To the best of my understanding this encapsulation can be used with any VCCV type
> 2.       “Raw” BFD in VCCV. This encapsulation relies on the dedicated ACH type to identify BFD packets and hence can be only used with VCCV Type 1 and VCCV Type 4.
> 
> However, I did not find any indication in RFC 5885 as to which BFD in VCCV encapsulation MUST be supported.
> This can easily result in an interoperability problem where two PEs claim  to support the same set of VCCV Types and BFD in VCCV, but are not interoperable because they support different encapsulations for BFD in VCCV.

This is incorrect. The different encapsulations have different CV Types, hence no such Interop confusion is possible. Claiming support (e.g., documentation) for “BFD over VCCV” ought to clarify if BFD PW-ACH-encapsulated, BFD IP/UDP-encapsulated, or both.

> 
> If you agree that this is a real issue, how should it be handled? Is it a case for just  a Technical Erratum, or is a new draft required?

Have you found this potential issue when implementing?

This has not proven to be an issue.

In addition, an update like that cannot be undertaken by an Erratum.

Please read the guidelines at http://www.ietf.org/iesg/statement/errata-processing.html and the pointers at https://www.rfc-editor.org/errata.php

Thanks,

— Carlos.

> And, last but not least, which encapsulation should be declared as mandatory to implement?
> 
> Regards, and lots of thanks in advance,
> Sasha
> 
> Office: +972-39266302
> Cell:      +972-549266302
> Email:   [email-masked] <mailto:[email-masked]>

---

From: Alexander Vainshtein <[email-masked]>
Date: Mon, 16 May 2016 04:54:21 +0000

Carlos,
Lots of thanks for a prompt response.

The interoperability issue is quite real: there are devices supporting only IP/UDP-based encapsulation and there are devices supporting only raw one. So there is no way for such a pair of devices to run BFD in VCCV on a PW they set up between them.

It has been my understanding that IETF protocols providing multiple incompatible implementation options options always specify one of these options as MUST to implement to assure that any two implementatuons claiming "compliance to the RFC" would be able to interop my using this option.

My problem is that this is not true for 5885.

I also agree that this is not the case fir an Erratum, and I have doubts regarding the MUST to implement encapsulation.

But from my POV the problem is there😉.

Regards,

Thumb typed on my cellphone
Regards,
Sasha

-------- Original Message --------
From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Mon, May 16, 2016 3:09 AM +0300
To: Alexander Vainshtein <[email-masked]>
CC: "Andrew G. Malis ([email-masked])" <[email-masked]>, "Stewart Bryant ([email-masked])" <[email-masked]>, [email-masked]
Subject: Re: Mandatory Encapsulation for BFD in VCCV is lacking in RFC 5885?

Sasha,

On May 15, 2016, at 6:19 AM, Alexander Vainshtein <[email-masked]<mailto:[email-masked]>> wrote:

As you surely remember RFC 5885<https://tools.ietf.org/html/rfc5885>   has defined two possible encapsulations for BFD in VCCV:
1.       Encapsulation that uses IP and UDP headers. To the best of my understanding this encapsulation can be used with any VCCV type
2.       “Raw” BFD in VCCV. This encapsulation relies on the dedicated ACH type to identify BFD packets and hence can be only used with VCCV Type 1 and VCCV Type 4.

Thanks,

— Carlos.

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]<mailto:[email-masked]>

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Mon, 16 May 2016 05:20:49 +0000

Sasha,

Are you seeing this "interop issue" (as you describe) when implementing? Section 3.3 explains the considerations and requirements regarding each of the two encapsulations.

Again, there's no "interop" issue at all in RFC 5885. There are different code points signaled for the two encaps, and only the intersection is considered. Then there's a specific selection criteria of there are multiple possible.

Further, in the case of RFC 5885, defining an MTI does not make sense: some PWs will use a CW and some might not. What's Implementing in a mandatory way a PW-ACH encapsulation when there's no CW? And why mandate an IP encap when most PWs will use a CW?

LDP runs over IPv4 as well as IPv6. Which one of those two is MTI? What if there's an IPv6 only stack implementing LDP? Can you point to an actual requirement to specify an MTI in every spec?

Thumb typed by Carlos Pignataro.
Excuze typofraphicak errows

On May 16, 2016, at 00:54, Alexander Vainshtein <[email-masked]<mailto:[email-masked]>> wrote:

Carlos,

But from my POV the problem is there?.

Regards,

-------- Original Message --------
From: "Carlos Pignataro (cpignata)" <[email-masked]<mailto:[email-masked]>>
Date: Mon, May 16, 2016 3:09 AM +0300
To: Alexander Vainshtein <[email-masked]<mailto:[email-masked]>>
CC: "Andrew G. Malis ([email-masked]<mailto:[email-masked]>)" <[email-masked]<mailto:[email-masked]>>, "Stewart Bryant ([email-masked]<mailto:[email-masked]>)" <[email-masked]<mailto:[email-masked]>>, [email-masked]<mailto:[email-masked]>
Subject: Re: Mandatory Encapsulation for BFD in VCCV is lacking in RFC 5885?

Sasha,

Andy, Stewart, Carlos and all,
I would highly appreciate your feedback on the following issue.
( I do not know Tom's current email address and so cannot send this email to him directly.)

As you surely remember RFC 5885<https://tools.ietf.org/html/rfc5885>   has defined two possible encapsulations for BFD in VCCV:
1.       Encapsulation that uses IP and UDP headers. To the best of my understanding this encapsulation can be used with any VCCV type
2.       "Raw" BFD in VCCV. This encapsulation relies on the dedicated ACH type to identify BFD packets and hence can be only used with VCCV Type 1 and VCCV Type 4.

This is incorrect. The different encapsulations have different CV Types, hence no such Interop confusion is possible. Claiming support (e.g., documentation) for "BFD over VCCV" ought to clarify if BFD PW-ACH-encapsulated, BFD IP/UDP-encapsulated, or both.

Thanks,

- Carlos.

Office: +972-39266302
Cell:      +972-549266302

---

From: Alexander Vainshtein <[email-masked]>
Date: Mon, 16 May 2016 15:19:36 +0000

Carlos,
Several comments to your response:

1.       The problem has been observed in a closed interoperability test.

2.       We seem to understand the term “interoperability issue” a bit differently:

a.       From your POV the scenario when two implementations that claim compliance to RFC 5885 exchange the information about their supported CV types, do not find any common one and decide not to use BFD in VCCV is not an interoperability issue

b.      From my POV it is an interoperability issue because some desired and apparently available functionality cannot be provided

3.       Raw BFD in VSSV is not limited to PWs that support CW now, as these PWs can use VCCV Type 4 (RFC 7708<https://datatracker.ietf.org/doc/rfc7708/?include_text=1>) that provides ACH Type without CW

4.       I fully agree with you that selecting the right “MUST to implement” option for BFD in VCCV is not simple. But I do not think that this means that it should not be specified. (Of course, we may find out that there is no way to specify that, but we should try☺).

Regards,
Sasha

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]

From: Carlos Pignataro (cpignata) [mailto:[email-masked]]
Sent: Monday, May 16, 2016 8:21 AM
To: Alexander Vainshtein
Cc: Andrew G. Malis ([email-masked]); Stewart Bryant ([email-masked]); [email-masked]
Subject: Re: Mandatory Encapsulation for BFD in VCCV is lacking in RFC 5885?

Sasha,

Carlos,

Regards,

Regards,

Sasha

-------- Original Message --------

Sasha,

Thanks,

— Carlos.

Office: +972-39266302
Cell:      +972-549266302

---

From: "Rajiv Asati (rajiva)" <[email-masked]>
Date: Mon, 16 May 2016 18:07:59 +0000

Sasha,

> From my POV it is an interoperability issue because some desired and apparently available functionality cannot be
> provided

Is this one of the scenarios you are alluding to - implementation A supports “PW Fault detection” capability, whereas implementation B supports “PW fault detection & Fault Status signaling” capability?

Is your claim that these 2 implementations are able to claim the compliance with RFC5885, but can not interoperate, because there is no common capability? 

-- 
Cheers,
Rajiv Asati

-----Original Message-----
From: Pals <[email-masked]> on behalf of Alexander Vainshtein <[email-masked]>
Date: Monday, May 16, 2016 at 11:19 AM
To: Carlos Pignataro <[email-masked]>
Cc: "Stewart Bryant ([email-masked])" <[email-masked]>, "Andrew G. Malis ([email-masked])" <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: Re: [Pals] Mandatory Encapsulation for BFD in VCCV is lacking in	RFC 5885?

>1.      
>The problem has been observed in a closed interoperability test.
>2.      
>We seem to understand the term “interoperability issue” a bit differently:
>a.      
>From your POV the scenario when two implementations that claim compliance to RFC 5885 exchange the information about their
> supported CV types, do not find any common one and decide not to use BFD in VCCV is not an interoperability issue
>b.     
>From my POV it is an interoperability issue because some desired and apparently available functionality cannot be provided
>3.      
>Raw BFD in VSSV is not limited to PWs that support CW now, as these PWs can use VCCV Type 4
>(RFC 7708 <https://datatracker.ietf.org/doc/rfc7708/?include_text=1>) that provides ACH Type without CW
>4.      
>I fully agree with you that selecting the right “MUST to implement” option for BFD in VCCV is not simple. But I do not think
> that this means that it should not be specified. (Of course, we may find out that there is no way to specify that, but we should tryJ).
> 
>Regards,
>Sasha
> 
>Office: +972-39266302
>Cell:      +972-549266302
>On May 16, 2016, at 00:54, Alexander Vainshtein <[email-masked]> wrote:
>
>
>Carlos,Lots of thanks for a prompt response. The interoperability issue is quite real: there are devices supporting only IP/UDP-based encapsulation and there are devices supporting only raw one. So there is no way for such a pair of devices to run BFD in VCCV on a PW they set up between them. It has been my understanding that IETF protocols providing multiple incompatible implementation options options always specify one of these options as MUST to implement to assure that any two implementatuons claiming "compliance to the RFC" would be able to interop my using this option. My problem is that this is not true for 5885. I also agree that this is not the case fir an Erratum, and I have doubts regarding the MUST to implement encapsulation. But from my POV the problem is there😉. Regards, Thumb typed on my cellphoneRegards,Sasha -------- Original Message --------From: "Carlos Pignataro (cpignata)" <[email-masked]>Date: Mon, May 16, 2016 3:09 AM +0300To: Alexander Vainshtein <[email-masked]>CC: "Andrew G. Malis ([email-masked])" <[email-masked]>, "Stewart Bryant ([email-masked])" <[email-masked]>, [email-masked]: Re: Mandatory Encapsulation for BFD in VCCV is lacking in RFC 5885? Sasha, 
> 
>
>As you surely remember RFC 5885 <https://tools.ietf.org/html/rfc5885>   has
> defined two possible encapsulations for BFD in VCCV:
>
>1.       Encapsulation
> that uses IP and UDP headers. To the best of my understanding this encapsulation can be used with any VCCV type
>
>2.       “Raw”
> BFD in VCCV. This encapsulation relies on the dedicated ACH type to identify BFD packets and hence can be only used with VCCV Type 1 and VCCV Type 4.
>
> 
>
>This can easily result in an interoperability problem where two PEs claim  to support the same set of VCCV Types and BFD in VCCV, but are not interoperable because they support
> different encapsulations for BFD in VCCV.
>
>
>
>
>
> 
>

---

From: Alexander Vainshtein <[email-masked]>
Date: Mon, 16 May 2016 18:14:07 +0000

Rajiv,
No this is the case when one implementation supports only encapsulation with IP and UDP headers snd the other one - only raw BFD encapsulation.

Both ue the PW CW and VCCV Type 1.

-------- Original Message --------
From: "Rajiv Asati (rajiva)" <[email-masked]>
Date: Mon, May 16, 2016 9:08 PM +0300
To: Alexander Vainshtein <[email-masked]>, "Carlos Pignataro (cpignata)" <[email-masked]>
CC: "Stewart Bryant ([email-masked])" <[email-masked]>, "Andrew G. Malis ([email-masked])" <[email-masked]>, [email-masked]
Subject: Re: [Pals] Mandatory Encapsulation for BFD in VCCV is lacking in RFC 5885?

Sasha,

--
Cheers,
Rajiv Asati